//------------------------------------------------------------------
#property link      "www.forex-tsd.com"
#property copyright "www.forex-tsd.com"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 6
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  Orange
#property indicator_color4  Orange
#property indicator_color5  Aqua
#property indicator_color6  Yellow
#property indicator_width1  2
#property indicator_width3  2
#property indicator_width5  1
#property indicator_width6  2
#property indicator_level1  0
#property indicator_levelcolor White

//
//
//
//
//

extern string TimeFrame       = "Current time frame";
extern double Period1         =  32;
extern double Period2         =   5;
extern double Period3         =   5;
extern double Signal          =   5;
extern double OmaSpeed        = 1.5;
extern bool   OmaAdaptive     = true;
extern bool   alertsOn        = false;
extern bool   alertsOnCurrent = false;
extern bool   alertsMessage   = false;
extern bool   alertsSound     = false;
extern bool   alertsEmail     = false;
extern bool   Interpolate     = true;

//
//
//
//
//

double tvi[];
double sig[];
double tvihuu[];
double tvihud[];
double tvihdd[];
double tvihdu[];
double slope[];
double trend[];

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorDigits(5);
   IndicatorBuffers(8);
   SetIndexBuffer(0,tvihuu); SetIndexStyle(0, DRAW_HISTOGRAM);
   SetIndexBuffer(1,tvihud); SetIndexStyle(1, DRAW_HISTOGRAM);
   SetIndexBuffer(2,tvihdd); SetIndexStyle(2, DRAW_HISTOGRAM);
   SetIndexBuffer(3,tvihdu); SetIndexStyle(3, DRAW_HISTOGRAM);
   SetIndexBuffer(4,tvi);
   SetIndexBuffer(5,sig);
   SetIndexBuffer(6,slope);
   SetIndexBuffer(7,trend);

      //
      //
      //
      //
      //
         
      timeFrame         = stringToTimeFrame(TimeFrame);
      indicatorFileName = WindowExpertName();
      returnBars        = TimeFrame=="returnBars";       if (returnBars)     return(0);
      calculateValue    = (TimeFrame=="calculateValue"); if (calculateValue) return(0);

      //
      //
      //
      //   
      //
      
      IndicatorShortName(timeFrameToString(timeFrame)+" OMA Blau etgodick tick volume indicator ("+DoubleToStr(Period1,1)+","+DoubleToStr(Period2,1)+","+DoubleToStr(Period3,1)+")");
   return(0);
}
int deinit() { return(0); }

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int count,counted_bars=IndicatorCounted();
      if(counted_bars < 0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { tvi[0] = MathMin(limit+1,Bars-1); return(0); }

   //
   //
   //
   //
   //

   if (calculateValue || timeFrame == Period())
   {
      for(int i = limit; i >= 0; i--)
      {
         double upTicks = (Volume[i]+(Close[i]-Open[i])/Point) / 2.0;
         double dnTicks = (Volume[i] - upTicks);
         double avgUp = iOma(iOma(upTicks,Period1,OmaSpeed,OmaAdaptive,i,0),Period2,OmaSpeed,OmaAdaptive,i,1);
         double avgDn = iOma(iOma(dnTicks,Period1,OmaSpeed,OmaAdaptive,i,2),Period2,OmaSpeed,OmaAdaptive,i,3);
            if (avgUp+avgDn != 0)
                  tvi[i] = iOma(100.0*(avgUp-avgDn)/(avgUp+avgDn),Period3,OmaSpeed,OmaAdaptive,i,4);
            else  tvi[i] = iOma(0                                ,Period3,OmaSpeed,OmaAdaptive,i,4);                  
            sig[i] = iOma(tvi[i],Signal,OmaSpeed,OmaAdaptive,i,5);                  
            tvihuu[i] = EMPTY_VALUE;
            tvihud[i] = EMPTY_VALUE;
            tvihdd[i] = EMPTY_VALUE;
            tvihdu[i] = EMPTY_VALUE;

            //
            //
            //
            //
            //
                           
            slope[i] = slope[i+1];
            trend[i] = trend[i+1];
               if (tvi[i] > sig[i+1]) trend[i] =  1;
               if (tvi[i] < sig[i+1]) trend[i] = -1;
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (tvi[i]>0)
               if (slope[i]==1)
                     tvihuu[i] = tvi[i];
               else  tvihud[i] = tvi[i];
               if (tvi[i]<0)
               if (slope[i]==1)
                     tvihdu[i] = tvi[i];
               else  tvihdd[i] = tvi[i];
      }
      manageAlerts();
      return(0);
   }
   
   //
   //
   //
   //
   //
   
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period()));
   for (i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         tvi[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Signal,OmaSpeed,OmaAdaptive,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,4,y);
         sig[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",Period1,Period2,Period3,Signal,OmaSpeed,OmaAdaptive,alertsOn,alertsOnCurrent,alertsMessage,alertsSound,alertsEmail,5,y);
         tvihuu[i] = EMPTY_VALUE;
         tvihud[i] = EMPTY_VALUE;
         tvihdd[i] = EMPTY_VALUE;
         tvihdu[i] = EMPTY_VALUE;
         slope[i]  = slope[i+1];
               if (tvi[i] > tvi[i+1]) slope[i] =  1;
               if (tvi[i] < tvi[i+1]) slope[i] = -1;
               if (!Interpolate || y==iBarShift(NULL,timeFrame,Time[i-1])) continue;

         //
         //
         //
         //
         //

         datetime time = iTime(NULL,timeFrame,y);
            for(int n = 1; i+n < Bars && Time[i+n] >= time; n++) continue;	
            for(int k = 1; k < n; k++)
            {
               tvi[i+k]  = tvi[i]  + (tvi[i+n] - tvi[i] )*k/n;
               sig[i+k]  = sig[i]  + (sig[i+n] - sig[i] )*k/n;
            }               
   }
   for (i=limit; i>=0; i--)
   {
      if (tvi[i]>0)
         if (slope[i]==1)
               tvihuu[i] = tvi[i];
         else  tvihud[i] = tvi[i];
      if (tvi[i]<0)
         if (slope[i]==1)
               tvihdu[i] = tvi[i];
         else  tvihdd[i] = tvi[i];
   }
      
   //
   //
   //
   //
   //

   return(0);
         
}


//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      if (alertsOnCurrent)
           int whichBar = 0;
      else     whichBar = 1; 
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"up");
         if (trend[whichBar] == -1) doAlert(whichBar,"down");
      }
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message = timeFrameToString(Period())+" "+Symbol()+" at "+TimeToStr(TimeLocal(),TIME_SECONDS)+" blau ergodic tvi trend changed to "+doWhat;
          if (alertsMessage) Alert(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," Blau ergodic tvi"),message);
          if (alertsSound)   PlaySound("alert2.wav");
   }
}

//------------------------------------------------------------------
//                                                                  
//------------------------------------------------------------------
//
//
//
//
//

double workOma[][42];
#define F01 0
#define F02 1
#define F03 2
#define F04 3
#define F05 4
#define F06 5
#define prc 6

//
//
//
//
//

double iOma(double price, double averagePeriod, double constant, bool adaptive, int r, int s=0)
{
   if (averagePeriod <=1) return(price);
   if (ArrayRange(workOma,0) != Bars) ArrayResize(workOma,Bars); r=Bars-r-1; s *=7;
   if (r<=1) 
   {
      for (int i=0; i<6; i++) workOma[r][i  +s] = 0;
                              workOma[r][prc+s] = price;
                              return(price);
   }      
   double f01=workOma[r-1][F01+s];  double f02=workOma[r-1][F02+s];
   double f03=workOma[r-1][F03+s];  double f04=workOma[r-1][F04+s];
   double f05=workOma[r-1][F05+s];  double f06=workOma[r-1][F06+s];

   //
   //
   //
   //
   //

      if (adaptive && (averagePeriod > 1))
      {
         double minPeriod = MathMin(averagePeriod,r)/2.0;
         double maxPeriod = MathMin(minPeriod*5.0,r);
         int    endPeriod = (int)MathCeil(maxPeriod);
         double signal    = MathAbs((price-workOma[r-endPeriod][prc+s]));
         double noise     = 0.00000000001;

            for(i=1; i<endPeriod; i++) noise=noise+MathAbs(price-workOma[r-i][prc+s]);

         averagePeriod = ((signal/noise)*(maxPeriod-minPeriod))+minPeriod;
      }
      
      //
      //
      //
      //
      //
      
      double Kg = (2.0+constant)/(1.0+constant+averagePeriod);
      double Hg = 1.0-Kg;

      f01 = Kg * price + Hg * f01; f02 = Kg * f01 + Hg * f02; double v01 = 1.5 * f01 - 0.5 * f02;
      f03 = Kg * v01   + Hg * f03; f04 = Kg * f03 + Hg * f04; double v02 = 1.5 * f03 - 0.5 * f04;
      f05 = Kg * v02   + Hg * f05; f06 = Kg * f05 + Hg * f06; double v03 = 1.5 * f05 - 0.5 * f06;

   //
   //
   //
   //
   //

   workOma[r][F01+s] = f01;  workOma[r][F02+s] = f02;
   workOma[r][F03+s] = f03;  workOma[r][F04+s] = f04;
   workOma[r][F05+s] = f05;  workOma[r][F06+s] = f06;
   workOma[r][prc+s] = price;
   return(v03);
}
//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = stringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}
string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string stringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int char = StringGetChar(s, length);
         if((char > 96 && char < 123) || (char > 223 && char < 256))
                     s = StringSetChar(s, length, char - 32);
         else if(char > -33 && char < 0)
                     s = StringSetChar(s, length, char + 224);
   }
   return(s);
}